BuildRequires: jpackage-1.5-compat
Name: tomcat5
Version: 5.5.16
Release: alt1.1
Summary: Apache Servlet/JSP Engine, RI for Servlet 2.4/JSP 2.0 API
License: Apache Software License

Group: Development/Java
Url: http://jakarta.apache.org/tomcat/
BuildArch: noarch

%define packdname	apache-tomcat-%version-src

%define tomcat_home %_libdir/%name
%define tomcat_user tomcat
%define tomcat_group apache

%define confdir		%_sysconfdir/%name
%define logdir		%_var/log/%name
%define bindir		%tomcat_home/bin
%define tempdir		%_localstatedir/%name/temp
%define workdir		%_localstatedir/%name/work
%define appdir		%tomcat_home/webapps
%define serverdir	%tomcat_home/server
%define commondir	%tomcat_home/common
%define shareddir	%tomcat_home/shared

Source: %packdname.tar.bz2
Source1: jasper-compiler-jdt.jar
Source2: eclipse-jdt.license.html
Source4: %name.init
Source5: %name-5.0.conf
Source8: %name-5.0.logrotate

Patch0: tomcat5-5.5-jt5-build.patch
Patch1: tomcat5-5.5-jtc-build.patch
Patch2: tomcat5-5.5-http11-build.patch
Patch3: tomcat5-5.5-util-build.patch
Patch4: tomcat5-5.5-jk-build.patch
Patch5: tomcat5-5.5-skip-build-on-install.patch
Patch6: tomcat5-5.5.link_admin_jar.patch

BuildPreReq: /proc rpm-build-java
BuildRequires: ant ant-optional jaxp_transform_impl jakarta-commons-beanutils jakarta-commons-collections
BuildRequires: jakarta-commons-daemon jakarta-commons-dbcp jakarta-commons-digester
BuildRequires: jakarta-commons-logging jakarta-commons-fileupload jakarta-commons-modeler
BuildRequires: jakarta-commons-pool jakarta-commons-launcher jakarta-commons-el jaf javamail
BuildRequires: jndi junit mx4j jakarta-regexp struts jaxp_parser_impl xml-commons-apis
BuildRequires: jakarta-taglibs-standard servletapi5

Requires: java-common

%description
Tomcat is the servlet container that is used in the official
Reference Implementation for the Java Servlet and
JavaServer Pages technologies.
Tomcat conforms to the Servlet 2.4 and JSP 2.0 specifications.

This package contains jar archives implementing the Tomcat5 engine.
If you need to deploy Java web applications, install the
%name-server package.

%package server
Summary: Apache Tomcat 5 Servlet/JSP server
Group: System/Servers
Requires: %name = %version-%release
Requires: ant jakarta-regexp jakarta-commons-beanutils jakarta-commons-collections
Requires: jakarta-commons-daemon jakarta-commons-dbcp jakarta-commons-digester jakarta-commons-modeler
Requires: jakarta-commons-pool jakarta-commons-logging jakarta-commons-fileupload jakarta-commons-launcher
Requires: jakarta-commons-el mx4j jndi servletapi5 jsvc
# non-free stuff
Requires: jaf javamail j2se

%description server
This is the default installation of the Tomcat Servlet/JSP container.
The server is set up as a system service.

%package webapps
Group: Networking/WWW
Requires: %name-server = %version-%release
Requires: jakarta-taglibs-standard
Summary: Web Applications for tomcat

%description webapps
Web Applications for tomcat

%package webapps-admin
Group: Networking/WWW
Requires: %name-server = %version-%release
Provides: %name-admin-webapps = %version-%release
Requires: struts
Summary: Admin Web Applications for tomcat

%description webapps-admin
Admin Web Applications for tomcat

%prep
%setup -q -c -T -a 0

cd %packdname

%patch0
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6

cat >> build/build.properties <<EOF
ant.jar=%_javadir/ant/ant.jar
ant-launcher.jar=%_javadir/ant/ant-launcher.jar
jtc.home=$RPM_BUILD_DIR/%name-%version/%packdname/connectors/
jasper.home=$RPM_BUILD_DIR/%name-%version/%packdname/jasper/jasper2
commons-beanutils.jar=%_javadir/jakarta-commons-beanutils.jar
commons-fileupload.jar=%_javadir/jakarta-commons-fileupload.jar
commons-collections.jar=%_javadir/jakarta-commons-collections.jar
commons-daemon.jar=%_javadir/jakarta-commons-daemon.jar
commons-dbcp.jar=%_javadir/jakarta-commons-dbcp.jar
commons-digester.jar=%_javadir/jakarta-commons-digester.jar
commons-el.jar=%_javadir/jakarta-commons-el.jar
commons-launcher.jar=%_javadir/jakarta-commons-launcher.jar
commons-logging.jar=%_javadir/jakarta-commons-logging.jar
commons-logging-api.jar=%_javadir/jakarta-commons-logging-api.jar
commons-modeler.jar=%_javadir/jakarta-commons-modeler.jar
commons-pool.jar=%_javadir/jakarta-commons-pool.jar
jmx.jar=%_javadir/jmx_impl.jar
jmx-tools.jar=%_javadir/mx4j.jar
jmxri.jar=%_javadir/jmx_impl.jar
junit.jar=%_javadir/junit.jar
regexp.jar=%_javadir/jakarta-regexp.jar
servlet-api.jar=%_javadir/servletapi5.jar
jsp-api.jar=%_javadir/jspapi5.jar
servlet.doc=%_javadocdir/servletapi5
xercesImpl.jar=%_javadir/jaxp_parser_impl.jar
xml-apis.jar=%_javadir/xml-commons-apis.jar
activation.jar=%_javadir/jaf.jar
mail.jar=%_javadir/javamail/mailapi.jar
jndi.jar=%_javadir/jndi.jar
struts.jar=%_javadir/struts.jar
servletapi.build.notrequired=true
jspapi.build.notrequired=true
EOF


%build

# Remove pre-build jars
for dir in %packdname ; do
    find $dir -name "*.jar" -delete
done

export CLASSPATH=%_javadir/xml-commons-apis.jar:%_javadir/jaxp_transform_impl.jar
# build jsp-api, servlet-api as ant dist will later on require them for webapps
pushd %packdname/servletapi
	pushd jsr154
		%__ant -Dservletapi.build=build -Dservletapi.dist=dist -Dbuild.compiler=modern dist
	popd
	pushd jsr152
		%__ant -Dservletapi.build=build -Dservletapi.dist=dist -Dbuild.compiler=modern dist
	popd
popd

export CLASSPATH=%_javadir/jaxp_transform_impl.jar:%_javadir/xml-commons-apis.jar:%_javadir/jspapi5.jar:\
%_javadir/jstl.jar:%_javadir/jakarta-taglibs-standard.jar:%SOURCE1

pushd %packdname/build
%__ant -Dstruts.lib=%_datadir/struts dist
popd

%install
cd %packdname/build

cp %SOURCE2 .

# build initial path structure
%__install -d -m 755 %buildroot{%confdir,%logdir,%tomcat_home,%bindir}
%__install -d -m 755 %buildroot{%serverdir/{classes,lib,webapps},%tempdir,%workdir}
%__install -d -m 755 %buildroot{%appdir,%commondir/{classes,endorsed,i18n,lib},%shareddir/{classes,lib}}
%__install -d -m 755 %buildroot{%_sysconfdir/{rc.d/init.d,logrotate.d},%_javadir/%name}

# sysv init and logging
%__install -m 755 %SOURCE4 %buildroot%_sysconfdir/rc.d/init.d/%name
%__install -m 644 %SOURCE5 %buildroot/%confdir/%name.conf

# install jars
%__install -m 644 dist/bin/bootstrap.jar %buildroot%_javadir/%name
%__install -m 644 dist/bin/tomcat-juli.jar %buildroot%_javadir/%name
%__install -m 644 dist/common/i18n/*.jar %buildroot%_javadir/%name
%__install -m 644 dist/common/lib/jasper-*.jar %buildroot%_javadir/%name
%__install -m 644 %SOURCE1 %buildroot%commondir/lib/
%__install -m 644 dist/common/lib/naming-*.jar %buildroot%_javadir/%name
%__install -m 644 dist/server/lib/*.jar %buildroot%_javadir/%name
%__install -m 644 dist/server/lib/servlets-cgi*jar %buildroot%_javadir/%name/servlets-cgi.jar
%__install -m 644 dist/server/lib/servlets-ssi*jar %buildroot%_javadir/%name/servlets-ssi.jar
%__rm -f %buildroot%_javadir/%name/jakarta-*.jar

%__cp -pR dist/conf/* %buildroot%confdir
%__cp -pR dist/server/webapps/*  %buildroot%serverdir/webapps
%__cp -pR dist/webapps/* %buildroot%appdir

# create reloctomcat5
cat >> %buildroot%bindir/reloctomcat5<<EOF
#!/bin/sh
#

echo "relocating http & ajp ports to 81xx"

sed -e 's;8080;8180;' \
    -e 's;8081;8181;' \
    -e 's;8082;8182;' \
    -e 's;8443;8543;' \
    -e 's;8009;8109;' \
    %confdir/server.xml > %confdir/server.xml.reloc

mv %confdir/server.xml %confdir/server.xml.bak
cp %confdir/server.xml.reloc %confdir/server.xml

EOF

# install logrotate support
install %SOURCE8 %buildroot%_sysconfdir/logrotate.d/%name

# FHS
for i in %buildroot%confdir/%name.conf %buildroot%_sysconfdir/logrotate.d/%name
do
    %__subst "s|\@\@\@TCCONF\@\@\@|%confdir|" $i
    %__subst "s|\@\@\@TCHOME\@\@\@|%tomcat_home|" $i
    %__subst "s|\@\@\@TCBIN\@\@\@|%bindir|" $i
    %__subst "s|\@\@\@TCCOMMON\@\@\@|%commondir|" $i
    %__subst "s|\@\@\@TCSERVER\@\@\@|%serverdir|" $i
    %__subst "s|\@\@\@TCSHARED\@\@\@|%shareddir|" $i
    %__subst "s|\@\@\@TCAPP\@\@\@|%appdir|" $i
    %__subst "s|\@\@\@TCLOG\@\@\@|%logdir|" $i
done

# Process admin webapp server/webapps/admin
%__rm -f %buildroot/%serverdir/webapps/admin/WEB-INF/lib/commons-collections.jar

%__ln_s $(relative %confdir %tomcat_home/conf) %buildroot%tomcat_home/conf
%__ln_s $(relative %logdir %tomcat_home/logs) %buildroot%tomcat_home/logs
%__ln_s $(relative %workdir %tomcat_home/work) %buildroot%tomcat_home/work
%__ln_s $(relative %tempdir %tomcat_home/temp) %buildroot%tomcat_home/temp

cd $RPM_BUILD_DIR/%name-%version/%packdname
find %buildroot%tomcat_home -type l -maxdepth 1 | sed s+%buildroot++g > homelinks

# Tomcat's jars
for jar in	bootstrap tomcat-juli
do
	ln -sf $(relative %_javadir/%name/bootstrap.jar %bindir/) %buildroot%bindir/
done

for jar in	jasper-compiler jasper-runtime naming-factory naming-resources
do
	ln -sf $(relative %_javadir/%name/$jar.jar %commondir/lib/) \
		%buildroot%commondir/lib/
done

for jar in	en es fr ja
do
	ln -sf $(relative %_javadir/%name/tomcat-i18n-$jar.jar %commondir/i18n/) \
		%buildroot%commondir/i18n/
done

for jar in	catalina-ant catalina-ant-jmx catalina-cluster catalina catalina-optional \
		catalina-storeconfig servlets-cgi servlets-default servlets-invoker \
		servlets-ssi servlets-webdav tomcat-ajp tomcat-apr tomcat-coyote \
		tomcat-http tomcat-jkstatus-ant tomcat-util
do
	ln -sf $(relative %_javadir/%name/$jar.jar %serverdir/lib/) \
		%buildroot%serverdir/lib/
done

# Not tomcat's jars

for jar in	jakarta-commons-daemon jakarta-commons-logging-api
do
	%__ln_s $(relative %_javadir/$jar.jar %bindir/) \
		%buildroot%bindir/
done

for jar in	jakarta-commons-modeler
do
	%__ln_s $(relative %_javadir/$jar.jar %serverdir/lib/) \
		%buildroot%serverdir/lib/
done

for jar in	jakarta-commons-dbcp jakarta-commons-el \
                jspapi5 servletapi5
do
	%__ln_s $(relative %_javadir/$jar.jar %commondir/lib/) \
		%buildroot%commondir/lib/
done

for jar in	struts jakarta-commons-collections jakarta-commons-beanutils \
		jakarta-commons-digester
do
	ln -sf $(relative %_javadir/$jar.jar %serverdir/webapps/admin/WEB-INF/lib/) \
		%buildroot%serverdir/webapps/admin/WEB-INF/lib
done

ln -sf $(relative %_javadir/jakarta-commons-fileupload.jar %serverdir/webapps/manager/WEB-INF/lib/) \
		%buildroot%serverdir/webapps/manager/WEB-INF/lib

for jar in	jakarta-taglibs-standard jstl
do
	ln -sf $(relative %_javadir/$jar.jar %appdir/jsp-examples/WEB-INF/lib/) \
		%buildroot%appdir/jsp-examples/WEB-INF/lib
done

%pre server
%_sbindir/groupadd -r -f %tomcat_group >/dev/null 2>&1 ||:
%_sbindir/useradd -r -g %tomcat_group -c "Tomcat server" -d %tomcat_home -s /dev/null -n %tomcat_user \
        >/dev/null 2>&1 ||:

%post server
%post_service %name

%post webapps
/sbin/service %name condrestart

%post webapps-admin
/sbin/service %name condrestart

%preun server
# Always clean up wordir and tempdir on upgrade/removal
rm -fr %workdir/* %tempdir/*
%preun_service %name

%preun webapps-admin
[ $1 != 0 ] || /sbin/service %name condrestart

%preun webapps
[ $1 != 0 ] || /sbin/service %name condrestart

%files 
%dir %_javadir/%name
%_javadir/%name/*.jar

%files server -f %packdname/homelinks
%doc %packdname/build/{LICENSE,RELE*,RUNNING.txt,BENCHMARKS.txt,eclipse-jdt.license.html}
# Normal directories
%dir %tomcat_home
%dir %bindir
%dir %commondir
%commondir/lib/jasper-compiler-jdt.jar
%dir %serverdir
%dir %serverdir/classes
%dir %serverdir/lib
%dir %shareddir
%dir %shareddir/classes
%dir %shareddir/lib

# Directories with special permissions
%attr(750,root,%tomcat_group) %dir %appdir
%attr(775,root,%tomcat_group) %dir %confdir
%attr(770,root,%tomcat_group) %dir %tempdir
%attr(770,root,%tomcat_group) %dir %workdir
%attr(775,root,%tomcat_group) %dir %logdir
%attr(775,root,%tomcat_group) %dir %confdir/Catalina
%attr(775,root,%tomcat_group) %dir %confdir/Catalina/localhost

%attr(755,root,root) %bindir/*
%attr(755,root,root) %_sysconfdir/rc.d/init.d/%name

%attr(644,root,%tomcat_group) %config(noreplace) %confdir/catalina.policy
%attr(644,root,%tomcat_group) %config(noreplace) %confdir/catalina.properties
%attr(660,root,%tomcat_group) %config(noreplace) %confdir/tomcat-users.xml
%config(noreplace) %confdir/tomcat5.conf
%config(noreplace) %confdir/server-minimal.xml
%config(noreplace) %confdir/server.xml
%config(noreplace) %confdir/web.xml
%config(noreplace) %confdir/logging.properties
%config(noreplace) %confdir/context.xml

# %confdir/server-noexamples.xml.config
%config(noreplace) %_sysconfdir/logrotate.d/%name
%commondir/*
%serverdir/lib/*

%files webapps
%defattr(644,root,%tomcat_group,755)
%dir %appdir/servlets-examples
%appdir/servlets-examples/*
%dir %appdir/jsp-examples
%appdir/jsp-examples/*
%dir %appdir/ROOT
%appdir/ROOT/*
%dir %appdir/tomcat-docs
%appdir/tomcat-docs/*
%dir %appdir/webdav
%appdir/webdav/*

%files webapps-admin
%defattr(640,root,%tomcat_group,750)
%attr(660,root,%tomcat_group) %confdir/Catalina/localhost/manager.xml
%confdir/Catalina/localhost/host-manager.xml
%confdir/Catalina/localhost/admin.xml
%dir %appdir/balancer
%appdir/balancer/*
%dir %serverdir/webapps
%serverdir/webapps/*

%changelog
* Mon May 07 2007 Igor Vlasenko <viy@altlinux.ru> 5.5.16-alt1.1
- rebuild with java-1.4
- provides tomcat-admin-webapps

* Sat Mar 25 2006 Vladimir Lettiev <crux@altlinux.ru> 5.5.16-alt1
- 5.5.16

* Tue Apr 05 2005 Vladimir Lettiev <crux@altlinux.ru> 5.0.30-alt1
- Initial build for ALT Linux Sisyphus

